(* Berechnet die Primfaktorenzerlegung von n mit Hilfe
   des folgenden Algorithmus.
   -------- Algorithmus -----------------------------------
   Wiederhole...
     Falls n durch i (i=2,3,5,7,...) dividiert werden kann,
     notiere i und ersetze n durch n/i.
   ... bis n=1.
   Die notierten i's sind die Faktoren der PFZ.
   -------- Ende des Algorithmus ---------------------------
   Bsp.: n=4004
         i=2  n=2002
         i=2  n=2002
         i=7  n=143
         i=11 n=13
         i=13 n=1
   Also: 4004=2*2*7*11*13
   Eine Beschleunigung erreicht man durch folgende berlegung:
   Ist n=a*b so muss ein Faktor a oder b kleiner/gleich sqrt(n) sein.
   (Widerspuchsbeweis: a>sqrt(n) und b>sqrt(n) => a*b>n )
   Man braucht also nur mgliche Faktoren i<=sqrt(n) betrachten.
*)


unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    BBerechne: TButton;
    Label1: TLabel;
    LPFZ: TLabel;
    Button1: TButton;
    ComboBox1: TComboBox;
    procedure BBerechneClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure EnKeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function PFZ(n:integer):string;
  var i:integer;
begin
  result:='';
  i:=2;
  repeat
    while n mod i =0 do BEgin
      n:=n div i;
      if result<>'' then result:=result+'*'; //Das 1. Mal kein '*'
      result:=result+floatToStr(i);
    ENd;
    if i=2 then i:=i+1
     else i:=i+2;
    if i>trunc(sqrt(n)) then i:=n; //ohne diese Zeile:Kaffeepause!
  until n=1;
  if pos('*',result)=0 then result:='Primzahl';
end;

function copyab(const s:string; const i:integer):string;
  //Rest von s ab i. em Zeichen
begin result:=copy(s,i,length(s)-i+1) end;


function ohneLeerzeichenf(const s:string):string;
   var n:integer;
begin
   result:=s;
   repeat
     n:=pos(' ',result);
     if n>0 then result:=copy(result,1,n-1)+copyab(result,n+1)
   until n=0;
end;

procedure TForm1.BBerechneClick(Sender: TObject);
  var n:integer;
begin
  n:=strToInt(ohneLeerzeichenf(combobox1.text));
  LPFZ.caption:=PFZ(n);
end;



(* Ohne Funktion PFZ und sqrt(n) fr Einsteiger.
procedure TForm1.BBerechneClick(Sender: TObject);
   var n,i:integer;
       ns,PFZ:string;
begin
  ns:=En.text;
  n:=strToInt(ns);
  PFZ:='';
  i:=2;
  repeat
    while n mod i =0 do BEgin
      n:=n div i;
      if PFZ<>'' then PFZ:=PFZ+'*';
      PFZ:=PFZ+floatToStr(i);
    ENd;
    i:=i+1;
  until n=1;
  LPFZ.caption:=PFZ;
end;*)

procedure TForm1.Button1Click(Sender: TObject);
begin
 close
end;

procedure TForm1.EnKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then BBerechneClick(Nil);
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  LPFZ.caption:=''; //damit kein falsches Ergebnis dasteht
end;

procedure TForm1.ComboBox1KeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then BBerechneClick(self);
end;

end.
